"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const commander_1 = require("commander");
const cli_1 = require("./cli");
const output_1 = require("./output");
function getArgv() {
    const baseArgv = process.argv;
    const command = baseArgv[2];
    if (command === 'exportCP' ||
        command === 'importCP' ||
        command === 'exportPC' ||
        command === 'importPC' ||
        command === 'stake' ||
        command === 'delegate') {
        return [...baseArgv.slice(0, 2), 'transaction', ...baseArgv.slice(2)];
    }
    else if (command === 'addresses' ||
        command === 'network' ||
        command === 'balance' ||
        command === 'validators') {
        return [...baseArgv.slice(0, 2), 'info', ...baseArgv.slice(2)];
    }
    else {
        return baseArgv;
    }
}
const program = new commander_1.Command("Flare Stake Tool");
(0, cli_1.cli)(program).then(() => {
    program.parseAsync(getArgv()).catch(err => {
        if (err instanceof Error) {
            (0, output_1.logError)(`Error: ${err.message}`);
        }
    });
});
